module PlotLab.FigureSettings
       ( FigureSettings (..)
       , defaultSettings
       ) where

import           Graphics.Rendering.Plot

data FigureSettings =
  FigureSettings
  { fontFamily    :: String
  , plotTitle     :: Maybe String
  , plotTitleSize :: Double
  , subTitle      :: Maybe String
  , subTitleSize  :: Double
  , xRange        :: Maybe (Double, Double)
  , yRange        :: Maybe (Double, Double)
  , samplingRate  :: Int
  , xLabel        :: Maybe String
  , xLabelSize    :: Double
  , yLabel        :: Maybe String
  , yLabelSize    :: Double
  , showXAxis     :: Bool
  , xLocation     :: (AxisPosn, AxisSide)
  , showYAxis     :: Bool
  , yLocation     :: (AxisPosn, AxisSide)
  , plotScaleX    :: Graphics.Rendering.Plot.Scale
  , plotScaleY    :: Graphics.Rendering.Plot.Scale
  , exportSize    :: (Int, Int)
  , fileName      :: String
  }

defaultSettings :: FigureSettings
defaultSettings = FigureSettings
 { fontFamily    = "Sans"
 , plotTitle     = Nothing
 , plotTitleSize = 10
 , subTitle      = Nothing
 , subTitleSize  = 10
 , xRange        = Nothing
 , yRange        = Nothing
 , samplingRate  = 10
 , xLabel        = Nothing
 , xLabelSize    = 10
 , yLabel        = Nothing
 , yLabelSize    = 10
 , showXAxis     = True
 , xLocation     = (Side Lower, Lower)
 , showYAxis     = True
 , yLocation     = (Side Lower, Lower)
 , plotScaleX    = Linear
 , plotScaleY    = Linear
 , exportSize    = (1000, 1000)
 , fileName      = "plot"
 }
